"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestConsolidator = void 0;
var RequestConsolidator = /** @class */ (function () {
    function RequestConsolidator() {
        this.promiseMap = {};
    }
    RequestConsolidator.prototype.queue = function (type, promise) {
        var _this = this;
        var promiseConsolidator = this.promiseMap[type];
        if (!promiseConsolidator) {
            promiseConsolidator = new PromiseConsolidator(function () {
                delete _this.promiseMap[type];
            });
            this.promiseMap[type] = promiseConsolidator;
        }
        promiseConsolidator.addPromise(promise);
        return promiseConsolidator.result;
    };
    return RequestConsolidator;
}());
exports.RequestConsolidator = RequestConsolidator;
var PromiseConsolidator = /** @class */ (function () {
    function PromiseConsolidator(finallyFunction) {
        var _this = this;
        this.finally = finallyFunction;
        this.result = new Promise(function (resolve, reject) {
            _this.resolve = resolve;
            _this.reject = reject;
        });
    }
    PromiseConsolidator.prototype.addPromise = function (promise) {
        var _this = this;
        this.currentPromise = promise;
        promise
            .then(function (result) {
            var _a;
            if (promise === _this.currentPromise) {
                _this.resolve(result);
                (_a = _this.finally) === null || _a === void 0 ? void 0 : _a.call(_this);
            }
        })
            .catch(function (error) {
            var _a;
            _this.reject(error);
            (_a = _this.finally) === null || _a === void 0 ? void 0 : _a.call(_this);
        });
    };
    return PromiseConsolidator;
}());
//# sourceMappingURL=RequestConsolidator.js.map